/*  Time-stamp: <2005-04-19 18:11:34 >  */
#include  "4ru.h"
#include  <glut.h>
#include  "GLcolors.h"
#include  "PopE.xbm"
#include  "IGp.xbm"


extern int win_w;
extern int win_h;
extern double camera_x;
extern double camera_y;
extern double camera_z;
extern GLuint notescreen;
extern int view_devi;
extern int view_score;
extern int disp_vel;
extern GLdouble gosen_colors[8][4];

extern xmlDoc *gpr_doc_top;
extern xmlNode *gpr_top;
extern int gpr_view;

extern double Lbot;
extern double inter;
extern double Velbot;
extern double Veltop;
extern double ppqbeat;
extern double alpha;
extern double draw_on_time_bias;

extern int gpr_person;

extern WRITE_CTRL wctrl;

extern int genchan_mode;

extern char prog_name[STR_LEN];


int draw_all(NOTE_HEADER note_header_info, NOTE_NODE *view_note_cur, DRUM_DEF *drum_data)
{
  double Ltop;
  double BTbot;
  double BTtop;
  double damper_bot;
  double damper_top;
  char str_buf[STR_LEN];
  int BTl;
  int BTh;
  GLdouble line_colors[4];
  static GLdouble backicon_colors[8][4];
/*   int i; */


  if(strnicmp(prog_name, "PopE", 4) == 0){
    set_GLcolors_by_X11name("blue", backicon_colors);
    xbm_put(0, win_h - PopE_height - 20, 0, PopE_width, PopE_height, PopE_bits, backicon_colors[0]);
  }else{
    set_GLcolors_by_X11name("SkyBlue1", backicon_colors);
    xbm_put(0, win_h - IGp_height - 20, 0, IGp_width, IGp_height, IGp_bits, backicon_colors[0]);
  }

/*   glClear(GL_COLOR_BUFFER_BIT); */

/*   glMatrixMode(GL_PROJECTION); */
/*   glLoadIdentity(); */
/*   glOrtho(0.0, (double)win_w, 0.0, (double)win_h, 0.0, (double)win_w); */

/*   glMatrixMode(GL_MODELVIEW); */
/*   glLoadIdentity(); */
/*   gluLookAt(camera_x, camera_y, camera_z, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0); */

  sprintf(str_buf, "%04d : %04d: %04d\n", (int)camera_x, (int)camera_y, (int)camera_z);
  put_str(win_w - 110, win_h - 28, 0, OpenGLcolors[0], str_buf);

  sprintf(str_buf, "%d pixel / quater beat", (int)ppqbeat);
  put_str(win_w - 136, win_h - 14, 0, OpenGLcolors[0], str_buf);


  if(gpr_person == YT){
    sprintf(str_buf, "44");
  }else if(gpr_person == MH){
    sprintf(str_buf, "324");
  }else if(gpr_person == (YT | MH) ){
    sprintf(str_buf, "44 & 324");
  }else{
    strcpy(str_buf, "");
  }
  put_str(win_w - 100, win_h - 64, 0, OpenGLcolors[0], str_buf);

  inter = 12;          /* $B8^@~$N4V3V(B ($B%T%/%;%k(B) */
  Lbot = draw_gosen(inter, gosen_colors, &Lbot, &Ltop);

  /*  Velocity $BI=<((B  */
  Veltop = Lbot - VELTOP_BIAS;
  if(gpr_view == ON){
/*   if( (gpr_view == ON) || (genchan_mode == ON) ){ */
    Veltop -= 140;
  }
  Velbot = (Veltop / 3) * 2;
  /*  $B@D$C$]$$3%?'(B  */
  line_colors[0] = 0.8;
  line_colors[1] = 0.8;
  line_colors[2] = 1.0;
  line_colors[3] = 1.0;
  draw_H_line(0, Veltop, win_w, Veltop, line_colors, 2);
  put_str(0, Veltop + 4, 0, OpenGLcolors[0], "Velocity 127");
  draw_H_line(0, Velbot, win_w, Velbot, OpenGLcolors[0], 2);

  /*  BEATTIME, BPM $BI=<((B  */
  BTtop = Velbot - BTTOP_BIAS;
  BTbot = BTtop / 2;
  /*  $B@D$C$]$$3%?'(B  */
  line_colors[0] = 0.8;
  line_colors[1] = 0.8;
  line_colors[2] = 1.0;
  line_colors[3] = 1.0;
  BTl = 250;  /*  $BI=<(2<8B(B  250ms  */
  BTh = 3000; /*  $BI=<(>e8B(B 3000ms  */
  draw_H_line(0, BTtop, win_w, BTtop, line_colors, 2);
  sprintf(str_buf, "BEATTIME %4dms/qnote (%d QBPM)", BTl, 60000 / BTl);
  put_str(0, BTtop + 4, 0, OpenGLcolors[0], str_buf);
  draw_H_line(0, BTbot, win_w, BTbot, OpenGLcolors[0], 2);
  sprintf(str_buf, "BEATTIME %4dms/qnote (%d QBPM)", BTh, 60000 / BTh);
  put_str(0, BTbot + 4, 0, OpenGLcolors[0], str_buf);


  /*  Damper $BI=<((B  */
  damper_top = BTbot - damper_TOP_BIAS;
  damper_bot = 0;
  /*  $B@D$C$]$$3%?'(B  */
  line_colors[0] = 0.8;
  line_colors[1] = 0.8;
  line_colors[2] = 1.0;
  line_colors[3] = 1.0;
  draw_H_line(0, damper_top, win_w, damper_top, line_colors, 2);
  put_str(0, damper_bot + 4, 0, OpenGLcolors[0], "Damper 127");
  draw_H_line(0, damper_bot, win_w, damper_bot, OpenGLcolors[0], 2);
  put_str(0, damper_top + 4, 0, OpenGLcolors[0], "Damper   0");


  draw_NOTElist(note_header_info, view_note_cur, Lbot, Ltop, inter, Velbot, Veltop, BTbot, BTtop, BTl, BTh,
		damper_bot, damper_top, ppqbeat, alpha, drum_data);


  draw_gen_point("ls1", "cyan", NULL);
  draw_gen_point("ls2", "yellow", NULL);
  draw_gen_line("*sa", "red");
  draw_gen_line("*s", "blue");


/*   draw_gen_point("s1", "cyan"); */
/*   draw_gen_point("a1", "pink"); */
/*   draw_gen_point("e1", "green"); */

/*   draw_gen_point("s2", "cyan"); */
/*   draw_gen_point("a2", "pink"); */
/*   draw_gen_point("e2", "green"); */

  if(gpr_view == ON){
    disp_gpr(Lbot);
  }

  if(view_score == ON){
    put_str(0, win_h - 16 * 1, 0, OpenGLcolors[0], "Regularized note");
  }else{
    put_str(0, win_h - 16 * 1, 0, OpenGLcolors[0], "Real Performance");
  }

  if(view_devi == ON){
    put_str(0, win_h - 16 * 2, 0, OpenGLcolors[0], "Deviation Display:  ");
    put_str(-1, -1, -1, OpenGLcolors[2], "On");
  }else{
    put_str(0, win_h - 16 * 2, 0, OpenGLcolors[0], "Deviation Display:  Off");
  }

  if(disp_vel == ON){
    put_str(0, win_h - 16 * 3, 0, OpenGLcolors[0], "Velocity Value Display:  ");
    put_str(-1, -1, -1, OpenGLcolors[2], "On");
  }else{
    put_str(0, win_h - 16 * 3, 0, OpenGLcolors[0], "Velocity Value Display:  Off");
  }

  put_str(0, win_h - 16 * 4, 0, OpenGLcolors[0], "File write mode: ");
  if(wctrl.ow_chk == ON){
    put_str(-1, -1, -1, OpenGLcolors[2], "Overwrite");
  }else{
    put_str(-1, -1, -1, OpenGLcolors[0], "Query");
  }

/*   glPopAttrib(); */
/*   glEndList(); */

/*   glCallList(notescreen); */

/*   glutSwapBuffers(); */


  return EXIT_SUCCESS;
}
