/*  Time-stamp: <2005-04-19 15:41:21 >  */
#include  "4ru.h"


xmlNode *gen_MusicXML_body(xmlNode **xml_top, NOTE_NODE *note_top, NOTE_HEADER *note_header_info, DRUM_DEF *drum_data)
{
  xmlNode *xml_cur = NULL;
  xmlNode *xml_part = NULL;
  xmlNode *xml_attr = NULL;
  xmlNode *xml_meas = NULL;
  xmlNode *xml_key = NULL;
  xmlNode *xml_clef = NULL;
  int meas_num;
  char str_tmp[STR_LEN];
  int divi;
  int key_sf;
  int key_maj_min;
  static NOTE_NODE *note_cur;
  NOTE_NODE *note_same;


  /*  part   */
  xml_part = xmlNewChild(*xml_top, NULL, BAD_CAST "part", NULL);
  xmlNewProp(xml_part, BAD_CAST "id", BAD_CAST "P1");

  meas_num = 0;

  /*  measure  */
/*   xml_meas = xmlNewChild(xml_part, NULL, BAD_CAST "measure", NULL); */
/*   sprintf(str_tmp, "%d", meas_num); */
/*   xmlNewProp(xml_meas, BAD_CAST "number", BAD_CAST str_tmp); */

  xml_meas = gen_XML_measure(&xml_part, NULL, &meas_num);


  /*  attributes  */
  xml_attr = xmlNewChild(xml_meas, NULL, BAD_CAST "attributes", NULL);

  /*  divisions  */
  divi = DEFAULT_SMF_DIVI;
  sprintf(str_tmp, "%d", divi);
  xml_cur = xmlNewChild(xml_attr, NULL, BAD_CAST "divisions", str_tmp);

  /*  key  */
  key_sf = 0;  /*  #, b ʤ  */
  key_maj_min = 1;  /*  major (ĹĴ)  */

  xml_key = xmlNewChild(xml_attr, NULL, BAD_CAST "key", NULL);

  sprintf(str_tmp, "%d", key_sf);
  xml_cur = xmlNewChild(xml_key, NULL, BAD_CAST "fifths", str_tmp);
  if(key_maj_min > 0){
    strcpy(str_tmp, "major");
  }else if(key_maj_min < 0){
    strcpy(str_tmp, "minor");
  }
  xml_cur = xmlNewChild(xml_key, NULL, BAD_CAST "mode", str_tmp);

  /*  time  */
  if( (note_header_info->beat_bunsi != -1) && (note_header_info->beat_bunbo != -1) ){
    gen_XML_time(&xml_attr, note_header_info->beat_bunsi, note_header_info->beat_bunbo);
  }

  /*  staves */
  /*  note ѴǤϡ1 ˸  */
  xml_cur = xmlNewChild(xml_attr, NULL, BAD_CAST "staves", "1");

  /*  clef  */
  xml_clef = xmlNewChild(xml_attr, NULL, BAD_CAST "clef", NULL);
  xmlNewProp(xml_clef, BAD_CAST "number", BAD_CAST "1");  /*  note ѴǤϡ1 ˸  */
  xml_cur = xmlNewChild(xml_clef, NULL, BAD_CAST "sign", "G");  /*  note ѴǤϡG clef ˸  */
  xml_cur = xmlNewChild(xml_clef, NULL, BAD_CAST "line", "2");  /*  G clef ϡ"2"  */

  /*  sound  */
  if( (note_header_info->bpm != -1) || (note_header_info->beattime != -1) ){
    gen_XML_sound(&xml_meas, note_header_info);
  }


  note_cur = note_top;
  while(1){
    if(note_cur == NULL){  break; }
    note_same = note_cur;
    while(1){
      if(note_same == NULL){  break; }
      switch(note_same->ident){
      case  NOTE:
	gen_XML_note(&xml_meas, note_same, divi, note_header_info->beat_bunbo, drum_data);
	break;

      case  BAR:
	br_printf(6, "Ф\n");
	/*  measure  */
	xml_meas = gen_XML_measure(&xml_part, note_same, &meas_num);
	break;


      default:
	break;
      }
      note_same = note_same->samenext;
    }
    note_cur = note_cur->next;
  }

  
  return xml_cur;

}
