#include  "xml2note.h"


xmlNode *ident_analyze(xmlNode *cur,
		       char composer[STR_LEN],
		       char generator[STR_LEN],
		       char encode_date[STR_LEN],
		       char rights[STR_LEN])
{
  strcpy(composer, "");
  strcpy(generator, "");
  strcpy(encode_date, "");
  strcpy(rights, "");

  /*  now: cur == "identification"  */

  cur = cur->children;
  /*  now: cur == ("identification" ̈̑w)  */

  while(cur != NULL){
    if(cur->type == XML_ELEMENT_NODE){
      if(xmlStrcmp(cur->name, (const xmlChar *)"creator") == 0){	/*  <creator>  */
	if(xmlStrcmp(xmlGetProp(cur, "type"), "composer") == 0){
#ifdef ICONV
	  strcpy(composer, iconv_if(cur->children->content, "SHIFT-JIS", "UTF-8"));
#else
	  strcpy(composer, cur->children->content);
#endif
	}
      }else if(xmlStrcmp(cur->name, (const xmlChar *)"encoding") == 0){	/*  <encoding>  */
	cur = cur->children;
	while(cur != NULL){
	  if(cur->type == XML_ELEMENT_NODE){
	    if(xmlStrcmp(cur->name, (const xmlChar *)"software") == 0){
#ifdef  ICONV
	      strcpy(generator, iconv_if(cur->children->content, "SHIFT-JIS", "UTF-8"));
#else
	      strcpy(generator, cur->children->content);
#endif
	    }else if(xmlStrcmp(cur->name, (const xmlChar *)"encoding-date") == 0){
#ifdef  ICONV
	      strcpy(encode_date, iconv_if(cur->children->content, "SHIFT-JIS", "UTF-8"));
#else
	      strcpy(encode_date, cur->children->content);
#endif
	    }	      
	  }
	  if(cur->next == NULL){
	    break;
	  }
	  cur = cur->next;
	}
	cur = cur->parent;
      }else if(xmlStrcmp(cur->name, (const xmlChar *)"rights") == 0){	/*  <rights>  */
#ifdef  ICONV
	strcpy(rights, iconv_if(cur->children->content, "SHIFT-JIS", "UTF-8"));
#else
	strcpy(rights, cur->children->content);
#endif

      }else{
	br_printf(3, "%s: %d: Skip: ident: %s (XML line: %d)\n",
		  __FILE__, __LINE__, cur->name, xmlGetLineNo(cur));
	/*  rights:  쌠  */
      }
    }
    if(cur->next == NULL){
      break;
    }
    cur = cur->next;
  }

  cur = cur->parent;  /*  now: cur == "identification"  */
  cur = cur->next; /*  now: cur == ("identification"  next m[h)  */

  return cur;
}

