#include  "xml2note.h"


/*
xmlNode *sound_analyze(xmlNode *cur, NOTE_NODE **part_cur, double *divisions,
			   double now_time, double pre_duration, int *default_vel)
*/
/*
xmlNode *sound_analyze(xmlNode *cur, NOTE_NODE **part_cur, double *divisions,
			   double now_time, int default_vel)
*/
xmlNode *sound_analyze(xmlNode *cur, NOTE_NODE **part_cur, double *divisions, double now_time)
{
  int inttmp;
  xmlChar *xcharptr;


  /*  now: cur == "sound"  */
  
  if((xcharptr = xmlGetProp(cur, "tempo")) != NULL){
    if((*part_cur)->ident == NO_INFO){
      (*part_cur)->ident = BPM;
      (*part_cur)->org_xml_on_time.beat = now_time;
      (*part_cur)->xml_on_time.beat = (*part_cur)->org_xml_on_time.beat;
      (*part_cur)->on_time.beat = (*part_cur)->org_xml_on_time.beat / (*divisions); 
    }
    (*part_cur)->xmlnode = cur;
    (*part_cur)->xml_step.beat = 0;
    
    sscanf(xcharptr, "%lf", &((*part_cur)->val[0]));  /* "tempo" */
    (*part_cur)->val[0] = (*part_cur)->val[0];
    (*part_cur)->val[1] = 16;  /*  $B;MJ,2;Id(B  */
    
    
    (*part_cur)->next = NOTE_NODE_alloc();
    (*part_cur)->next->pre = (*part_cur);
    (*part_cur) = (*part_cur)->next;
  }
  
  if((xcharptr = xmlGetProp(cur, "dynamics")) != NULL){
    if((*part_cur)->ident == NO_INFO){
      (*part_cur)->ident = DYNAMICS;
      (*part_cur)->org_xml_on_time.beat = now_time;
      (*part_cur)->xml_on_time.beat = (*part_cur)->org_xml_on_time.beat;
      (*part_cur)->on_time.beat = (*part_cur)->org_xml_on_time.beat / (*divisions);
    }
    sscanf(xcharptr, "%d", &inttmp);/* "dynamics" */
    /*  Dynamics (or MIDI velocity) are expressed as a percentage
	of the default forte value (90 for MIDI).  */
    /*  *default_vel = 90.0 * inttmp * 0.01;  */
    /*    (*part_cur)->val[0] = 90.0 * inttmp * 0.01;  */
    (*part_cur)->val[0] = 90.0 / 100.0 * inttmp;

    (*part_cur)->next = NOTE_NODE_alloc();
    (*part_cur)->next->pre = (*part_cur);
    (*part_cur) = (*part_cur)->next;
  }

  if((xcharptr = xmlGetProp(cur, "divisions")) != NULL){
    /*  <attributes> $B$N(B divisions $B$H!$$I$A$i$,M%0L$+!)(B
	$B$=$l$>$l!$2?$N$?$a$KB8:_$9$k$N$+!)(B
	Dolet for Finale $B$O(B <attributes> $B$K=q$-=P$9$h$&$@!%(B
    */
    if((*part_cur)->ident == NO_INFO){
      (*part_cur)->ident = DIVISIONS;
      (*part_cur)->org_xml_on_time.beat = now_time;
      (*part_cur)->xml_on_time.beat = (*part_cur)->org_xml_on_time.beat;
      (*part_cur)->on_time.beat = (*part_cur)->org_xml_on_time.beat / (*divisions);
    }
    (*part_cur)->xmlnode = cur;
    (*part_cur)->xml_step.beat = 0;
    
    sscanf(cur->children->content, "%lf", &((*part_cur)->val[0]) );
    *divisions = (*part_cur)->val[0];
    
    (*part_cur)->next = NOTE_NODE_alloc();
    (*part_cur)->next->pre = (*part_cur);
    (*part_cur) = (*part_cur)->next;
  }

  /*
    $B$[$+$K(B <sound> $B$N(B Prop $B$H$7$F(B 2003-12-10 $B8=:_!$<!$N$b$N$,(B direction.dtd $B$GDj5A$5$l$F$$$k!%(B
    tutorial.pdf $B$K$O!$(Bgrace, ornament $B$KMxMQ$G$-$k$H=q$$$F$"$k!%(B
    
    dacapo %yes-no; #IMPLIED
    segno CDATA #IMPLIED
    dalsegno CDATA #IMPLIED
    coda CDATA #IMPLIED
    tocoda CDATA #IMPLIED
    forward-repeat %yes-no; #IMPLIED
      fine CDATA #IMPLIED
      pizzicato %yes-no; #IMPLIED
  */


  /*  now: cur == "sound"  */
  return cur;
  
}
