/*  Time-stamp: <2004-09-24 19:05:17 >  */
#include  "xml2note.h"

/*
<!--
	Type indicates the graphic note type, Valid values (from
	shortest to longest) are 256th, 128th, 64th, 32nd, 16th,
	eighth, quarter, half, whole, breve, and long. The size
	attribute indicates full-size or cue-size, with full the
	default for regular notes and cue the default for cue
	and grace notes.
-->

==================================================================
<!--
	Duration is specified in division units. This is the
	intended duration vs. notated duration (for instance,
	swing eighths vs. even eighths, or differences in dotted
	notes in Baroque-era music). Differences in duration 
	specific to an interpretation or performance should use
	the note element's attack and release attributes. The 
	tie element indicates that a tie begins or ends with 
	this note. The tie element indicates sound; the tied 
	element indicates notation.
-->
<!ELEMENT duration (#PCDATA)>
<!ELEMENT tie EMPTY>
<!ATTLIST tie
    type %start-stop; #REQUIRED
>

*/


int type2dur(xmlChar *type, int division, double bar_haku)
{
/*   printf("type: %s, divi: %d, %5.3f\n", type, division, bar_haku); */

  if(xmlStrcmp(type, "256th") == 0){
    return (4.0 / 256.0) * division;
  }else if(xmlStrcmp(type, "128th") == 0){
    return (4.0 / 128.0) * division;
  }else if(xmlStrcmp(type, "64th") == 0){
    return (4.0 / 64.0) * division;
  }else if(xmlStrcmp(type, "32nd") == 0){
    return (4.0 / 32.0) * division;
  }else if(xmlStrcmp(type, "16th") == 0){
    return (4.0 / 16.0) * division;
  }else if(xmlStrcmp(type, "eighth") == 0){
    return (4.0 /  8.0) * division;
  }else if(xmlStrcmp(type, "quarter") == 0){
    return (4.0 /  4.0) * division;
  }else if(xmlStrcmp(type, "half") == 0){
    return (4.0 /  2.0) * division;
  }else if(xmlStrcmp(type, "whole") == 0){
    return (bar_haku /  1.0) * division;
  }else if(xmlStrcmp(type, "breve") == 0){
    return (bar_haku *  2.0) * division;
  }else if(xmlStrcmp(type, "long") == 0){
    return (bar_haku *  4.0) * division;
  }else{
    br_printf(2, "\"type: %s\" is undefined.\n", type);
    exit(EXIT_FAILURE);
  }
}
